const SSDPError = require("../error/upnp_da11_ssdp_error");
class MsearchMessage{
  constructor(parsedSSDP){
    this.parsedSSDP = parsedSSDP;
    if(this.host==undefined) throw new SSDPError("host mandatory in ssdp message");
    if(this.man==undefined) throw new SSDPError("man control mandatory in ssdp message");
    if(this.ST==undefined) throw new SSDPError("ST mandatory in ssdp message");  
}
  get host() {return this.parsedSSDP.HOST?this.parsedSSDP.HOST:undefined;}
  get man() {return this.parsedSSDP.MAN?this.parsedSSDP.MAN:undefined;}
  get ST() {return this.parsedSSDP.ST?this.parsedSSDP.ST:undefined;}
  get userAgent(){return this.parsedSSDP['USER-AGENT']?this.parsedSSDP['USER-AGENT']:undefined;}
}

module.exports=MsearchMessage;