const SSDPError = require("../error/upnp_da11_ssdp_error");

class MSOKMessage{
  constructor(parsedSSDP){
    this.parsedSSDP = parsedSSDP;
    
    if(this.cacheControl==undefined) throw new SSDPError("cache control mandatory in ssdp message");
    if(this.ext==undefined) throw new SSDPError("ext control mandatory in ssdp message");
    if(this.location==undefined) throw new SSDPError("location mandatory in ssdp message");
    if(this.Server==undefined) throw new SSDPError("server mandatory in ssdp message");  
    if(this.ST==undefined) throw new SSDPError("ST mandatory in ssdp message");
    if(this.USN==undefined) throw new SSDPError("USN mandatory in ssdp message");
    if ((this.server!=undefined) && (this.server.includes("UPNP/1.1"))) {
      if(this.BooIdUpnpOrg==undefined) throw new SSDPError("BOOTID.UPNP.ORG mandatory in ssdp message");
    }
  }
 
  get cacheControl() {return this.parsedSSDP['CACHE-CONTROL']?this.parsedSSDP['CACHE-CONTROL']:undefined;}
  get date() {return this.parsedSSDP.DATE?this.parsedSSDP.DATE:undefined;}
  get ext() {return this.parsedSSDP.EXT==""?this.parsedSSDP.EXT:undefined;}
  get location() {return this.parsedSSDP.LOCATION?this.parsedSSDP.LOCATION:undefined;}
  get Server() {return this.parsedSSDP.SERVER?this.parsedSSDP.SERVER:undefined;}  
  get ST() {return this.parsedSSDP.ST?this.parsedSSDP.ST:undefined;}
  get USN(){return this.parsedSSDP.USN?this.parsedSSDP.USN:undefined;}
  get BooIdUpnpOrg(){return this.parsedSSDP['BOOTID.UPNP.ORG']?this.parsedSSDP['BOOTID.UPNP.ORG']:undefined;}
  get ConfigIdUpnpOrg() {return this.parsedSSDP['CONFIGID.UPNP.ORG']?this.parsedSSDP['CONFIGID.UPNP.ORG']:undefined;}
  get SearchPortUpnpOrg() {return this.parsedSSDP['SEARCHPORT.UPNP;ORG']?this.parsedSSDP['SEARCHPORT.UPNP;ORG']:undefined;} 
}

module.exports=MSOKMessage;