const SSDPError = require("../error/upnp_da11_ssdp_error");
const EventEmitter=require("events").EventEmitter;
class NotifyMessage{
  constructor(parsedSSDP){
    this.parsedSSDP = parsedSSDP;
    
    var eventEmitter = new EventEmitter();
    
    if (this.host==undefined) throw new SSDPError("host mandatory in ssdp message");
    if (this.NTS==undefined) throw new SSDPError("NTS mandatory in ssdp message"); 
    if ( (this.NTS=="ssdp:alive") && (this.cacheControl==undefined) )throw new SSDPError("cache control mandatory in ssdp message");
    if ( (this.NTS!="ssdp:byebue") && (this.location==undefined)) throw new SSDPError("location mandatory in ssdp message");
    if (this.NT==undefined) throw new SSDPError("NT mandatory in ssdp message");
    if ( (this.NTS=="ssdp:alive") && (this.Server==undefined)) throw new SSDPError("server mandatory in ssdp message");   
    if (this.USN==undefined) throw new SSDPError("USN mandatory in ssdp message");  
    
    if ((this.server!=undefined) && (this.server.includes("UPNP/1.1"))) {
      if(this.BooIdUpnpOrg==undefined) throw new SSDPError("BOOTID.UPNP.ORG mandatory in ssdp message");   
      if(this.ConfigIdUpnpOrg==undefined) throw new SSDPError("CONFIGID.UPNP.ORG mandatory in ssdp message");   
      if((this.NTS=="ssdp:update") && (this.NextBootIdUpnpOrg==undefined)) throw new SSDPError("NEXTBOOTID.UPNP.ORG mandatory in ssdp message");   
      if((this.NTS!="ssdp:byebye") && (this.SearchPortUpnpOrg==undefined)) throw new SSDPError("SEARCHPORT.UPNP.ORG mandatory in ssdp message"); 
    }
    
    if (this.NTS=="ssdp:alive") {
      //to do

      
    }
    
    if (this.NTS=="ssdp:byebye"){
      USNRegistry.delete(this.USN);
      eventEmiter.emit("DELETE",this.USN);
    }
    
    if(this.NTS=="ssdp:update"){
      //to do
      eventEmitter.emit("UPDATE",this.USN);
    }
    
  }
  
  get host() {return this.parsedSSDP.HOST?this.parsedSSDP.HOST:undefined;}
  get cacheControl() {return this.parsedSSDP['CACHE-CONTROL']?this.parsedSSDP['CACHE-CONTROL']:undefined;}
  get location() {return this.parsedSSDP.LOCATION?this.parsedSSDP.LOCATION:undefined;}
  get NT() {return this.parsedSSDP.NT?this.parsedSSDP.NT:undefined;}
  get NTS() {return this.parsedSSDP.NTS?this.parsedSSDP.NTS:undefined;}
  get Server() {return this.parsedSSDP.SERVER?this.parsedSSDP.SERVER:undefined;}
  get USN(){return this.parsedSSDP.USN?this.parsedSSDP.USN:undefined;}
  get BooIdUpnpOrg(){return this.parsedSSDP['BOOTID.UPNP.ORG']?this.parsedSSDP['BOOTID.UPNP.ORG']:undefined;}
  get ConfigIdUpnpOrg() {return this.parsedSSDP['CONFIGID.UPNP.ORG']?this.parsedSSDP['CONFIGID.UPNP.ORG']:undefined;}
  get NextBootIdUpnpOrg() {return this.parsedSSDP['NEXTBOOTID.UPNP;ORG']?this.parsedSSDP['NEXTBOOTID.UPNP;ORG']:undefined;} 
  get SearchPortUpnpOrg() {return this.parsedSSDP['SEARCHPORT.UPNP.ORG']?this.parsedSSDP['SEARCHPORT.UPNP.ORG']:undefined;}
}

module.exports=NotifyMessage;